searchNodes=[{"doc":"Top-level module. Provides a convenient use macro for importing the most commonly used functions and macros. Due to performance reasons, many of the combinators are given non-combinatory implementations (ie: not everything is expressed in terms s and k )","ref":"Quark.html","title":"Quark","type":"module"},{"doc":"See Quark.Compose.&lt;|&gt;/2 .","ref":"Quark.html#%3C%7C%3E/2","title":"Quark.<|>/2","type":"function"},{"doc":"See Quark.Compose.compose/1 .","ref":"Quark.html#compose/1","title":"Quark.compose/1","type":"function"},{"doc":"See Quark.Compose.compose/2 .","ref":"Quark.html#compose/2","title":"Quark.compose/2","type":"function"},{"doc":"See Quark.SKI.constant/2 .","ref":"Quark.html#constant/2","title":"Quark.constant/2","type":"function"},{"doc":"See Quark.SKI.first/2 .","ref":"Quark.html#first/2","title":"Quark.first/2","type":"function"},{"doc":"See Quark.FixedPoint.fix/1 .","ref":"Quark.html#fix/1","title":"Quark.fix/1","type":"function"},{"doc":"See Quark.BCKW.flip/1 .","ref":"Quark.html#flip/1","title":"Quark.flip/1","type":"function"},{"doc":"See Quark.SKI.id/1 .","ref":"Quark.html#id/1","title":"Quark.id/1","type":"function"},{"doc":"See Quark.Sequence.origin/1 .","ref":"Quark.html#origin/1","title":"Quark.origin/1","type":"function"},{"doc":"See Quark.Sequence.pred/1 .","ref":"Quark.html#pred/1","title":"Quark.pred/1","type":"function"},{"doc":"See Quark.SKI.second/2 .","ref":"Quark.html#second/2","title":"Quark.second/2","type":"function"},{"doc":"See Quark.M.self_apply/1 .","ref":"Quark.html#self_apply/1","title":"Quark.self_apply/1","type":"function"},{"doc":"See Quark.Sequence.succ/1 .","ref":"Quark.html#succ/1","title":"Quark.succ/1","type":"function"},{"doc":"The classic BCKW combinators . A similar idea to SKI , but with different primitives.","ref":"Quark.BCKW.html","title":"Quark.BCKW","type":"module"},{"doc":"Normal (binary) function composition Examples iex&gt; sum_plus_one = b ( &amp; ( &amp;1 + 1 ) , &amp; Enum . sum / 1 ) iex&gt; [ 1 , 2 , 3 ] |&gt; sum_plus_one . ( ) 7","ref":"Quark.BCKW.html#b/0","title":"Quark.BCKW.b/0","type":"function"},{"doc":"","ref":"Quark.BCKW.html#b/1","title":"Quark.BCKW.b/1","type":"function"},{"doc":"","ref":"Quark.BCKW.html#b/2","title":"Quark.BCKW.b/2","type":"function"},{"doc":"","ref":"Quark.BCKW.html#b/3","title":"Quark.BCKW.b/3","type":"function"},{"doc":"Reverse (first) two arguments ( flip ). Aliased as flip . Examples iex&gt; c ( &amp; div / 2 ) . ( 1 , 2 ) 2 iex&gt; reverse_concat = c ( &amp; Enum . concat / 2 ) ...&gt; reverse_concat . ( [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] ) [ 4 , 5 , 6 , 1 , 2 , 3 ] iex&gt; flip ( &amp; div / 2 ) . ( 1 , 2 ) 2","ref":"Quark.BCKW.html#c/0","title":"Quark.BCKW.c/0","type":"function"},{"doc":"","ref":"Quark.BCKW.html#c/1","title":"Quark.BCKW.c/1","type":"function"},{"doc":"See Quark.BCKW.c/1 .","ref":"Quark.BCKW.html#flip/1","title":"Quark.BCKW.flip/1","type":"function"},{"doc":"See Quark.SKI.k/0 .","ref":"Quark.BCKW.html#k/0","title":"Quark.BCKW.k/0","type":"function"},{"doc":"See Quark.SKI.k/1 .","ref":"Quark.BCKW.html#k/1","title":"Quark.BCKW.k/1","type":"function"},{"doc":"See Quark.SKI.k/2 .","ref":"Quark.BCKW.html#k/2","title":"Quark.BCKW.k/2","type":"function"},{"doc":"Apply the same argument to a functon twice Examples iex&gt; repeat = w ( &amp; Enum . concat / 2 ) iex&gt; repeat . ( [ 1 , 2 ] ) [ 1 , 2 , 1 , 2 ] iex&gt; w ( &amp; Enum . zip / 2 ) . ( [ 1 , 2 , 3 ] ) [ { 1 , 1 } , { 2 , 2 } , { 3 , 3 } ]","ref":"Quark.BCKW.html#w/0","title":"Quark.BCKW.w/0","type":"function"},{"doc":"","ref":"Quark.BCKW.html#w/1","title":"Quark.BCKW.w/1","type":"function"},{"doc":"Function composition is taking two functions, and joining them together to create a new function. For example: Examples iex&gt; sum_plus_one = compose ( [ &amp; ( &amp;1 + 1 ) , &amp; Enum . sum / 1 ] ) ...&gt; sum_plus_one . ( [ 1 , 2 , 3 ] ) 7 In this case, we have joined Enum.sum with a function that adds one, to create a new function that takes a list, sums it, and adds one. Note that composition normally applies from right to left , though Quark provides the opposite in the form of *_forward functions.","ref":"Quark.Compose.html","title":"Quark.Compose","type":"module"},{"doc":"Infix compositon operator Examples iex&gt; sum_plus_one = fn x -&gt; x + 1 end &lt;|&gt; &amp; Enum . sum / 1 ...&gt; sum_plus_one . ( [ 1 , 2 , 3 ] ) 7 iex&gt; add_one = &amp; ( &amp;1 + 1 ) ...&gt; piped = [ 1 , 2 , 3 ] |&gt; Enum . sum ( ) |&gt; add_one . ( ) ...&gt; composed = [ 1 , 2 , 3 ] |&gt; ( ( add_one &lt;|&gt; &amp; Enum . sum / 1 ) ) . ( ) ...&gt; piped == composed true","ref":"Quark.Compose.html#%3C%7C%3E/2","title":"Quark.Compose.<|>/2","type":"function"},{"doc":"Infix &quot;forward&quot; compositon operator Examples iex&gt; sum_plus_one = ( &amp; Enum . sum / 1 ) &lt;~&gt; fn x -&gt; x + 1 end ...&gt; sum_plus_one . ( [ 1 , 2 , 3 ] ) 7 iex&gt; x200 = ( &amp; ( &amp;1 * 2 ) ) &lt;~&gt; ( &amp; ( &amp;1 * 10 ) ) &lt;~&gt; ( &amp; ( &amp;1 * 10 ) ) ...&gt; x200 . ( 5 ) 1000 iex&gt; add_one = &amp; ( &amp;1 + 1 ) ...&gt; piped = [ 1 , 2 , 3 ] |&gt; Enum . sum ( ) |&gt; add_one . ( ) ...&gt; composed = [ 1 , 2 , 3 ] |&gt; ( ( &amp; Enum . sum / 1 ) &lt;~&gt; add_one ) . ( ) ...&gt; piped == composed true","ref":"Quark.Compose.html#%3C~%3E/2","title":"Quark.Compose.<~>/2","type":"function"},{"doc":"Function composition, from the tail of the list to the head Examples iex&gt; sum_plus_one = compose ( [ &amp; ( &amp;1 + 1 ) , &amp; Enum . sum / 1 ] ) ...&gt; [ 1 , 2 , 3 ] |&gt; sum_plus_one . ( ) 7","ref":"Quark.Compose.html#compose/1","title":"Quark.Compose.compose/1","type":"function"},{"doc":"Function composition Examples iex&gt; sum_plus_one = compose ( &amp; ( &amp;1 + 1 ) , &amp; Enum . sum / 1 ) ...&gt; [ 1 , 2 , 3 ] |&gt; sum_plus_one . ( ) 7","ref":"Quark.Compose.html#compose/2","title":"Quark.Compose.compose/2","type":"function"},{"doc":"Compose functions, from the head of the list of functions. Examples iex&gt; sum_plus_one = compose_forward ( [ &amp; Enum . sum / 1 , &amp; ( &amp;1 + 1 ) ] ) ...&gt; sum_plus_one . ( [ 1 , 2 , 3 ] ) 7","ref":"Quark.Compose.html#compose_forward/1","title":"Quark.Compose.compose_forward/1","type":"function"},{"doc":"Function composition, from the head to tail (left-to-right) Examples iex&gt; sum_plus_one = compose_forward ( &amp; Enum . sum / 1 , &amp; ( &amp;1 + 1 ) ) ...&gt; [ 1 , 2 , 3 ] |&gt; sum_plus_one . ( ) 7","ref":"Quark.Compose.html#compose_forward/2","title":"Quark.Compose.compose_forward/2","type":"function"},{"doc":"Currying breaks up a function into a series of unary functions that apply their arguments to some inner n-ary function. This is a convenient way to achieve a general and flexible partial application on any curried function.","ref":"Quark.Curry.html","title":"Quark.Curry","type":"module"},{"doc":"Curry a function at runtime, rather than upon definition Examples iex&gt; curried_reduce_3 = curry &amp; Enum . reduce / 3 ...&gt; { _ , arity } = :erlang . fun_info ( curried_reduce_3 , :arity ) ...&gt; arity 1 iex&gt; curried_reduce_3 = curry &amp; Enum . reduce / 3 ...&gt; curried_reduce_3 . ( [ 1 , 2 , 3 ] ) . ( 42 ) . ( &amp; ( &amp;1 + &amp;2 ) ) 48","ref":"Quark.Curry.html#curry/1","title":"Quark.Curry.curry/1","type":"function"},{"doc":"Define a curried function","ref":"Quark.Curry.html#defcurry/2","title":"Quark.Curry.defcurry/2","type":"macro"},{"doc":"Define a curried private function","ref":"Quark.Curry.html#defcurryp/2","title":"Quark.Curry.defcurryp/2","type":"macro"},{"doc":"Convert a curried function to a function on pairs Examples iex&gt; curried_add = fn x -&gt; ( fn y -&gt; x + y end ) end iex&gt; add = uncurry curried_add iex&gt; add . ( 1 , 2 ) 3","ref":"Quark.Curry.html#uncurry/1","title":"Quark.Curry.uncurry/1","type":"function"},{"doc":"Apply one or more arguments to a curried function Examples iex&gt; curried_add = fn x -&gt; ( fn y -&gt; x + y end ) end ...&gt; uncurry ( curried_add , [ 1 , 2 ] ) 3 iex&gt; add_one = &amp; ( &amp;1 + 1 ) ...&gt; uncurry ( add_one , 1 ) 2 iex&gt; curried_add = fn x -&gt; ( fn y -&gt; x + y end ) end ...&gt; add_one = uncurry ( curried_add , 1 ) ...&gt; add_one . ( 3 ) 4","ref":"Quark.Curry.html#uncurry/2","title":"Quark.Curry.uncurry/2","type":"function"},{"doc":"Fixed point combinators generalize the idea of a recursive function. This can be used to great effect, simplifying many definitions. For example, here is the factorial function written in terms of y/1 : iex&gt; fac = fn fac -&gt; ...&gt; fn ...&gt; 0 -&gt; 0 ...&gt; 1 -&gt; 1 ...&gt; n -&gt; n * fac . ( n - 1 ) ...&gt; end ...&gt; end ...&gt; factorial = y ( fac ) ...&gt; factorial . ( 9 ) 362880 The resulting function will always be curried iex&gt; import Quark.SKI , only : [ s : 3 ] ...&gt; one_run = y ( &amp; s / 3 ) ...&gt; { _ , arity } = :erlang . fun_info ( one_run , :arity ) ...&gt; arity 1","ref":"Quark.FixedPoint.html","title":"Quark.FixedPoint","type":"module"},{"doc":"See Quark.FixedPoint.y/0 .","ref":"Quark.FixedPoint.html#fix/0","title":"Quark.FixedPoint.fix/0","type":"function"},{"doc":"See Quark.FixedPoint.y/1 .","ref":"Quark.FixedPoint.html#fix/1","title":"Quark.FixedPoint.fix/1","type":"function"},{"doc":"Alan Turing's fix-point combinator. This is the call-by-value formulation. Examples iex&gt; fac = fn fac -&gt; ...&gt; fn ...&gt; 0 -&gt; 0 ...&gt; 1 -&gt; 1 ...&gt; n -&gt; n * fac . ( n - 1 ) ...&gt; end ...&gt; end ...&gt; factorial = turing ( fac ) ...&gt; factorial . ( 9 ) 362880","ref":"Quark.FixedPoint.html#turing/0","title":"Quark.FixedPoint.turing/0","type":"function"},{"doc":"","ref":"Quark.FixedPoint.html#turing/1","title":"Quark.FixedPoint.turing/1","type":"function"},{"doc":"The famous Y-combinator. The resulting function will always be curried. Examples iex&gt; fac = fn fac -&gt; ...&gt; fn ...&gt; 0 -&gt; 0 ...&gt; 1 -&gt; 1 ...&gt; n -&gt; n * fac . ( n - 1 ) ...&gt; end ...&gt; end ...&gt; factorial = y ( fac ) ...&gt; factorial . ( 9 ) 362880","ref":"Quark.FixedPoint.html#y/0","title":"Quark.FixedPoint.y/0","type":"function"},{"doc":"","ref":"Quark.FixedPoint.html#y/1","title":"Quark.FixedPoint.y/1","type":"function"},{"doc":"A normal order fixed point. Examples iex&gt; fac = fn fac -&gt; ...&gt; fn ...&gt; 0 -&gt; 0 ...&gt; 1 -&gt; 1 ...&gt; n -&gt; n * fac . ( n - 1 ) ...&gt; end ...&gt; end ...&gt; factorial = z ( fac ) ...&gt; factorial . ( 9 ) 362880","ref":"Quark.FixedPoint.html#z/0","title":"Quark.FixedPoint.z/0","type":"function"},{"doc":"","ref":"Quark.FixedPoint.html#z/1","title":"Quark.FixedPoint.z/1","type":"function"},{"doc":"","ref":"Quark.FixedPoint.html#z/2","title":"Quark.FixedPoint.z/2","type":"function"},{"doc":"The self-applyication combinator","ref":"Quark.M.html","title":"Quark.M","type":"module"},{"doc":"Apply a function to itself. Also aliased as self_apply . Examples iex&gt; add_one = fn x -&gt; x + 1 end ...&gt; add_two = m ( add_one ) ...&gt; add_two . ( 8 ) 10","ref":"Quark.M.html#m/0","title":"Quark.M.m/0","type":"function"},{"doc":"","ref":"Quark.M.html#m/1","title":"Quark.M.m/1","type":"function"},{"doc":"See Quark.M.m/0 .","ref":"Quark.M.html#self_apply/0","title":"Quark.M.self_apply/0","type":"function"},{"doc":"See Quark.M.m/1 .","ref":"Quark.M.html#self_apply/1","title":"Quark.M.self_apply/1","type":"function"},{"doc":"Provide curried functions, that can also be partially bound without dot notation. Partially applying a function will always return a fully-curried function. Please note that these will use all of the arities up to the defined function. For instance: defpartial foo ( a , b , c ) , do : a + b + c #=&gt; foo/0, foo/1, foo/2, and foo/3 If you need to use an arity in the range below the original function, fall back to defcurry/2 and partially apply manually.","ref":"Quark.Partial.html","title":"Quark.Partial","type":"module"},{"doc":"A convenience on defcurry/2 . Generates a series of partially-bound applications of a fully-curried function, for all arities at and below the user-specified arity. For instance: defpartial add ( a , b ) , do : a + b #=&gt; add/0, add/1, add/2. Examples defmodule A do defpartial minus ( a , b , c ) , do : a - b - c end A . minus ( 3 , 2 , 1 ) #=&gt; 0 A . minus . ( 3 ) . ( 2 ) . ( 1 ) #=&gt; 0 below_ten = A . minus ( 10 ) below_ten . ( 2 ) . ( 1 ) #=&gt; 7 below_five = A . minus ( 20 , 15 ) below_five . ( 2 ) #=&gt; 3","ref":"Quark.Partial.html#defpartial/2","title":"Quark.Partial.defpartial/2","type":"macro"},{"doc":"defpartial/2 , but generates private functions.","ref":"Quark.Partial.html#defpartialp/2","title":"Quark.Partial.defpartialp/2","type":"macro"},{"doc":"Allows defining functions as straight function composition (ie: no need to state the argument). Provides a clean, composable named functions","ref":"Quark.Pointfree.html","title":"Quark.Pointfree","type":"module"},{"doc":"Define a unary function with an implied subject Examples iex&gt; defmodule Foo do ...&gt; import Quark.Pointfree ...&gt; defx foo ( ) , do : Enum . sum |&gt; fn x -&gt; x + 1 end . ( ) ...&gt; end ...&gt; Foo . foo ( [ 1 , 2 , 3 ] ) 7 iex&gt; defmodule Bar do ...&gt; import Quark.Pointfree ...&gt; defx bar , do : Enum . sum |&gt; fn x -&gt; x + 1 end . ( ) ...&gt; end ...&gt; Bar . bar ( [ 1 , 2 , 3 ] ) 7","ref":"Quark.Pointfree.html#defx/2","title":"Quark.Pointfree.defx/2","type":"macro"},{"doc":"Define a private unary function with an implied subject Examples defmodule Foo do import Quark.Pointfree defxp foo ( ) , do : Enum . sum |&gt; fn x -&gt; x + 1 end . ( ) end","ref":"Quark.Pointfree.html#defxp/2","title":"Quark.Pointfree.defxp/2","type":"macro"},{"doc":"The classic SKI system of combinators. s and k alone can be used to express any algorithm, though generally not efficiently.","ref":"Quark.SKI.html","title":"Quark.SKI","type":"module"},{"doc":"See Quark.SKI.k/2 .","ref":"Quark.SKI.html#constant/2","title":"Quark.SKI.constant/2","type":"function"},{"doc":"See Quark.SKI.k/2 .","ref":"Quark.SKI.html#first/2","title":"Quark.SKI.first/2","type":"function"},{"doc":"The identity combinator. Also aliased as id . iex&gt; i ( 1 ) 1 iex&gt; i ( &quot;identity combinator&quot; ) &quot;identity combinator&quot; iex&gt; [ 1 , 2 , 3 ] |&gt; id [ 1 , 2 , 3 ]","ref":"Quark.SKI.html#i/0","title":"Quark.SKI.i/0","type":"function"},{"doc":"","ref":"Quark.SKI.html#i/1","title":"Quark.SKI.i/1","type":"function"},{"doc":"See Quark.SKI.i/1 .","ref":"Quark.SKI.html#id/1","title":"Quark.SKI.id/1","type":"function"},{"doc":"The constant (&quot;Konstant&quot;) combinator. Returns the first argument unchanged, and discards the second argument. Can be used to repeatedly apply the same value in functions such as folds. Aliased as first and constant . Examples iex&gt; k ( 1 , 2 ) 1 iex&gt; k ( &quot;happy&quot; , &quot;sad&quot; ) &quot;happy&quot; iex&gt; Enum . reduce ( [ 1 , 2 , 3 ] , [ 42 ] , &amp; k / 2 ) 3 iex&gt; Enum . reduce ( [ 1 , 2 , 3 ] , [ 42 ] , &amp; constant / 2 ) 3 iex&gt; first ( 1 , 2 ) 1","ref":"Quark.SKI.html#k/0","title":"Quark.SKI.k/0","type":"function"},{"doc":"","ref":"Quark.SKI.html#k/1","title":"Quark.SKI.k/1","type":"function"},{"doc":"","ref":"Quark.SKI.html#k/2","title":"Quark.SKI.k/2","type":"function"},{"doc":"The &quot;substitution&quot; combinator. Applies the last argument to the first two, and then the first two to each other. Examples iex&gt; add = &amp; ( &amp;1 + &amp;2 ) ...&gt; double = &amp; ( &amp;1 * 2 ) ...&gt; s ( add , double , 8 ) 24","ref":"Quark.SKI.html#s/0","title":"Quark.SKI.s/0","type":"function"},{"doc":"","ref":"Quark.SKI.html#s/1","title":"Quark.SKI.s/1","type":"function"},{"doc":"","ref":"Quark.SKI.html#s/2","title":"Quark.SKI.s/2","type":"function"},{"doc":"","ref":"Quark.SKI.html#s/3","title":"Quark.SKI.s/3","type":"function"},{"doc":"Opposite of first (the k combinator). While not strictly part of SKI, it's a common enough case. Returns the second of two arguments. Can be used to repeatedly apply the same value in functions such as folds. Examples iex&gt; second ( 43 , 42 ) 42 iex&gt; Enum . reduce ( [ 1 , 2 , 3 ] , [ ] , &amp; second / 2 ) [ ]","ref":"Quark.SKI.html#second/0","title":"Quark.SKI.second/0","type":"function"},{"doc":"","ref":"Quark.SKI.html#second/1","title":"Quark.SKI.second/1","type":"function"},{"doc":"","ref":"Quark.SKI.html#second/2","title":"Quark.SKI.second/2","type":"function"},{"doc":"A protocol for stepping through ordered enumerables","ref":"Quark.Sequence.html","title":"Quark.Sequence","type":"protocol"},{"doc":"The beginning of the sequence. For instance, integers are generally thought of as centering around 0. Examples origin ( 9 ) #=&gt; 0","ref":"Quark.Sequence.html#origin/1","title":"Quark.Sequence.origin/1","type":"function"},{"doc":"The pred essor in the sequence. For integers, this is the number below. Examples pred ( 10 ) #=&gt; 9 42 |&gt; origin ( ) |&gt; pred ( ) |&gt; pred ( ) #=&gt; -2","ref":"Quark.Sequence.html#pred/1","title":"Quark.Sequence.pred/1","type":"function"},{"doc":"The succ essor in sequence. For integers, this is the number above. Examples iex&gt; succ ( 1 ) #=&gt; 2 iex&gt; 10 |&gt; origin ( ) |&gt; succ ( ) |&gt; succ ( ) #=&gt; 2","ref":"Quark.Sequence.html#succ/1","title":"Quark.Sequence.succ/1","type":"function"},{"doc":"","ref":"Quark.Sequence.html#t:t/0","title":"Quark.Sequence.t/0","type":"type"},{"doc":"Table of Contents Quick Start Summary Includes Functional Overview Curry Functions Macros Partial Macros Pointfree Compose Common Combinators Classics SKI System BCKW System Fixed Point Sequence Quick Start def deps do [ { :quark , &quot;~&gt; 2.3&quot; } ] end defmodule MyModule do use Quark # ... end Summary Elixir is a functional programming language, but it lacks some of the common built-in constructs that many other functional languages provide. This is not all-together surprising, as Elixir has a strong focus on handling the complexities of concurrency and fault-tolerance, rather than deeper functional composition of functions for reuse.","ref":"readme.html","title":"Quark: Common combinators for Elixir","type":"extras"},{"doc":"A series of classic combinators (SKI, BCKW, and fixed-points), along with friendlier aliases Fully-curried and partially applied functions Macros for defining curried and partially applied functions Composition helpers Composition operator: &lt;|&gt; A plethora of common functional programming primitives, including: id flip const pred succ fix self_apply Functional Overview","ref":"readme.html#includes","title":"Quark: Common combinators for Elixir - Includes","type":"extras"},{"doc":"Functions curry creates a 0-arity function that curries an existing function. uncurry applies arguments to curried functions, or if passed a function creates a function on pairs. Macros: defcurry and defcurryp Why define the function before currying it? defcurry and defcurryp return fully-curried 0-arity functions. defmodule Foo do import Quark.Curry defcurry div ( a , b ) , do : a / b defcurryp minus ( a , b ) , do : a - b end # Regular div ( 10 , 2 ) # =&gt; 5 # Curried div . ( 10 ) . ( 5 ) # =&gt; 2 # Partially applied div_ten = div . ( 10 ) div_ten . ( 2 ) # =&gt; 5","ref":"readme.html#curry","title":"Quark: Common combinators for Elixir - Curry","type":"extras"},{"doc":":crown: We think that this is really the crowning jewel of Quark . defpartial and defpartialp create all arities possible for the defined function, bare, partially applied, and fully curried. This does use up the full arity-space for that function name, however. Macros: defpartial and defpartialp defmodule Foo do import Quark.Partial defpartial one ( ) , do : 1 defpartial minus ( a , b , c ) , do : a - b - c defpartialp plus ( a , b , c ) , do : a + b + c end # Normal zero-arity one # =&gt; 1 # Normal n-arity minus ( 4 , 2 , 1 ) # =&gt; 1 # Partially-applied first two arguments minus ( 100 , 5 ) . ( 10 ) # =&gt; 85 # Partially-applied first argument minus ( 100 ) . ( 10 ) . ( 50 ) # =&gt; 40 # Fully-curried minus . ( 10 ) . ( 2 ) . ( 1 ) # =&gt; 7","ref":"readme.html#partial","title":"Quark: Common combinators for Elixir - Partial","type":"extras"},{"doc":"Allows defining functions as straight function composition (ie: no need to state the argument). Provides a clean, composable named functions. Also doubles as an aliasing device. defmodule Contrived do import Quark.Pointfree defx sum_plus_one , do : Enum . sum ( ) |&gt; fn x -&gt; x + 1 end . ( ) end Contrived . sum_plus_one ( [ 1 , 2 , 3 ] ) #=&gt; 7","ref":"readme.html#pointfree","title":"Quark: Common combinators for Elixir - Pointfree","type":"extras"},{"doc":"Compose functions to do convenient partial applications. Versions for composing left-to-right and right-to-left are provided The operator &lt;|&gt; is done &quot;the math way&quot; (right-to-left). The operator &lt;~&gt; is done &quot;the flow way&quot; (left-to-right). Versions on lists also available. import Quark.Compose # Regular Composition sum_plus_one = fn x -&gt; x + 1 end &lt;|&gt; &amp; Enum . sum / 1 sum_plus_one . ( [ 1 , 2 , 3 ] ) #=&gt; 7 add_one = &amp; ( &amp;1 + 1 ) piped = fn x -&gt; x |&gt; Enum . sum |&gt; add_one . ( ) end composed = add_one &lt;|&gt; &amp; Enum . sum / 1 piped . ( [ 1 , 2 , 3 ] ) == composed . ( [ 1 , 2 , 3 ] ) #=&gt; true sum_plus_one = ( &amp; Enum . sum / 1 ) &lt;~&gt; fn x -&gt; x + 1 end sum_plus_one . ( [ 1 , 2 , 3 ] ) #=&gt; 7 # Reverse Composition (same direction as pipe) x200 = ( &amp; ( &amp;1 * 2 ) ) &lt;~&gt; ( &amp; ( &amp;1 * 10 ) ) &lt;~&gt; ( &amp; ( &amp;1 * 10 ) ) x200 . ( 5 ) #=&gt; 1000 add_one = &amp; ( &amp;1 + 1 ) piped = fn x -&gt; x |&gt; Enum . sum ( ) |&gt; add_one . ( ) end composed = ( &amp; Enum . sum / 1 ) &lt;~&gt; add_one piped . ( [ 1 , 2 , 3 ] ) == composed . ( [ 1 , 2 , 3 ] ) #=&gt; true","ref":"readme.html#compose","title":"Quark: Common combinators for Elixir - Compose","type":"extras"},{"doc":"A number of basic, general functions, including id , flip , const , pred , succ , fix , and self_apply .","ref":"readme.html#common-combinators","title":"Quark: Common combinators for Elixir - Common Combinators","type":"extras"},{"doc":"SKI System The SKI system combinators. s and k alone can be combined to express any algorithm, but not usually with much efficiency. We've aliased the names at the top-level ( Quark ), so you can use const rather than having to remember what k means. 1 |&gt; i ( ) #=&gt; 1 &quot;identity combinator&quot; |&gt; i ( ) #=&gt; &quot;identity combinator&quot; Enum . reduce ( [ 1 , 2 , 3 ] , [ 42 ] , &amp; k / 2 ) #=&gt; 3 BCKW System The classic b , c , k , and w combinators. A similar &quot;full system&quot; as SKI, but with some some different functionality out of the box. As usual, we've aliased the names at the top-level ( Quark ). c ( &amp; div / 2 ) . ( 1 , 2 ) #=&gt; 2 reverse_concat = c ( &amp; Enum . concat / 2 ) reverse_concat . ( [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] ) #=&gt; [4,5,6,1,2,3] repeat = w ( &amp; Enum . concat / 2 ) repeat . ( [ 1 , 2 ] ) #=&gt; [1,2,1,2] Fixed Point Several fixed point combinators, for helping with recursion. Several formulations are provided, but if in doubt, use fix . Fix is going to be kept as an alias to the most efficient formulation at any given time, and thus reasonably future-proof. fac = fn fac -&gt; fn 0 -&gt; 0 1 -&gt; 1 n -&gt; n * fac . ( n - 1 ) end end factorial = y ( fac ) factorial . ( 9 ) #=&gt; 362880 Sequence Really here for pred and succ on integers, by why stop there? This works with any ordered collection via the Quark.Sequence protocol. succ 10 #=&gt; 11 42 |&gt; origin ( ) |&gt; pred ( ) |&gt; pred ( ) #=&gt; -2","ref":"readme.html#classics","title":"Quark: Common combinators for Elixir - Classics","type":"extras"}]